<?
	/****************************************************************************
	* Software distributed under the License is distributed on an "AS IS" 		*
	* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 	*
	* License for a specific language governing rights and limitations under	*
	* the License. 																*
	* 																			*
	*	The Original Code is - InTerra Blog Machine   				            *
	* 																			*
	*	The Initial Developer of the Original Code is 							*
	* 																			*
	* 			Kulikov Alexey <alex [at] essentialmind [dot] com>	 			*
	* 																			*
	* 				All Rights Reserved // www.inses.ru							*
	* 																			*
	* Read the full license in the license.rtf file distributed along with		*
	* this software package.													*
	*****************************************************************************/
	
	//check access
	if(!$_SESSION['admin']){
		header("Location: " . SERVER_ROOT);
		exit;	
	}
	

	//disable caching
	$smarty->caching = false;
	
	//include stuff
	include("lib/simpleRSS.class.php");
	
	/***
	 RSS Compiler, we are all we've got =)
	***/
	function recompileRSS($section=null){
		global $db;
		
		if(!$section){
			$desc = RSS_DESC;
			$title = RSS_HEADER;
			$link = SERVER_ROOT;
			$entries = $db->getAll("SELECT subject, entryid, content_p, intime FROM int_entry ORDER BY intime DESC LIMIT 10");
			$file = "entry.xml";
		}else{
			$section = $db->getRow("SELECT * FROM int_category WHERE catid = '$section'");
			$desc = RSS_DESC . " // " . $section['fullName'];
			$title = RSS_HEADER . " // " . $section['fullName'];
			$link = SERVER_ROOT . $section['name'] . "/";
			$file = $section['name'].".xml";
			
			$entries = $db->getAll("SELECT subject, entryid, content_p, intime FROM int_entry WHERE catid = '".$section['catid']."' ORDER BY intime DESC LIMIT 10");
		}
		
		$myRSS = new simpleRSS(	$title,
		 						$link,
		 						$desc,
								array(
										"ttl"			=>	60,
										"lastBuildDate"	=>	date("r"),
										"generator"		=>	"InTerra Blog Machine"));
		
		//get latest entries
		foreach($entries as $entry){
			$myRSS->addItem($entry['subject'],SERVER_ROOT."entry/".$entry['entryid']."/",htmlspecialchars($entry['content_p']),array("pubDate"=>date("r",$entry['intime'])));								
		}
		
		$myRSS->create("rss/".$file);	
	}
	
	
	
	//process POST
	if($_POST){
		//get some libraries
		require("lib/wacko/classes/macroProcessor.class.php");
		$parser = &new macroProcessor();
		
		//as only the admin can post, we do not clean the input, just process it
		//and insert into the database
		
		//error check
		$_POST['subject'] = trim($_POST['subject']);
		if(empty($_POST['subject'])){
			$_POST['subject'] = " ";
		}
		
		if(empty($_POST['content'])){
			$_POST['content'] = " ";
		}
		
		$parsedContent = $parser->process($_POST["content"]);
		$date = mktime($_POST['time']['Time_Hour'],$_POST['time']['Time_Minute'],0,$_POST['date']['Date_Month'],$_POST['date']['Date_Day'],$_POST['date']['Date_Year']);
		
		//section check
		if($_POST['section'] == "new"){
			
			//get rid of spaces if any
			$_POST['sectionNewUnix'] = trim($_POST['sectionNewUnix']);
			
			//check unix name validity
			if(!eregi("^[_a-z0-9-]{1,32}$",$_POST['sectionNewUnix'])){
				$error = true;
			}else{
				$error = false;	
			}

			
			//no errors?
			if(!$error){
				//check if this name is already taken...
				if($tempID = $db->getOne("SELECT catid FROM int_category WHERE name = '".$_POST['sectionNewUnix']."'")){
					$catID = $tempID;
					
				}else{
					$catID = (int)$db->getOne("SELECT max(catid) FROM int_category") + 1;	

					//insert new category
					$res = $db->query("INSERT INTO int_category(catid, name, fullName, hidden) VALUES('".$catID."','".$_POST['sectionNewUnix']."','".$_POST['sectionNewName']."','".$_POST['sectionNewHidden']."')");
				}
			}
			
		}else{
			$catID = $_POST['section'];
		}
		
		//figure out post id
		if($_POST['edit']){
			$newEntryID = (int)$_GET['id'];
		}else{
			$newEntryID = (int)$db->getOne("SELECT max(entryid) FROM int_entry") + 1;
		}
		
		## CASE file upload ##
		if(ALLOW_TEASER_IMAGE){
			//prepare files
			if($_FILES['myFile']['tmp_name']){
				//init library
				require("lib/uploader.class.php");			# image uploader
				
				//create uploader
				$myUpload = new uploader();		
				
				//check for existence of root path
				$uploadPath = "files" . DIRECTORY_SEPARATOR . $newEntryID . DIRECTORY_SEPARATOR;
				$myUpload->preparePath($uploadPath);
				
				//check if file with this name exists
				$myUpload->checkImage($uploadPath);
				
				//check file to be uploaded is a jpeg, and create a thumbnail for it
				$myUpload->copyFile($_FILES['myFile']['tmp_name'],$uploadPath."image.jpg");
				$myUpload->copyJPEG($uploadPath."image.jpg",$uploadPath."thumb.jpg",TI_WIDTH,TI_HEIGHT);
				
				//chmod
				@chmod($uploadPath."thumb.jpg", 0777);
				@chmod($uploadPath."image.jpg", 0777);
				
				$imageTag = 1;
			}else{
				if($_POST['image']){
					$imageTag = 1;
				}else{
					$imageTag = 0;
				}
			} //end file prepare	
		}else{
			$imageTag = 0;
		}
		## end CASE file upload ##
		
		
		## case LJ Syndicate ##
		if(ENABLE_LJ and $_POST['lj'] == '1'){
			
			require('lib/xmlrpc/xmlrpc.inc');
			require('lib/lj.class.php');
			
			//create LJ template
			$smarty->assign("entry",array( 	"subject"	=>	$_POST['subject'],
											"content"	=>	$parsedContent,
											"id"		=>	$newEntryID,
											"intime"	=>	$date,
											"image"		=>	$imageTag));		
			$myLJContent = $smarty->preFetch("postToLJ.htm");
			
			//create an LJ client
			$myLJ = new lj(LJ_USER,LJ_PASS);
			
			//is this a post or an update?
			if(!empty($_POST['ljid'])){
				$myLJ->updatePost($_POST['ljid'],$_POST['subject'],$myLJContent,$date);
			}else{
				if($ljID = $myLJ->addPost($_POST['subject'],$myLJContent,$date)){
					$ljURL = $ljID['itemid']*256 + $ljID['anum'];
				}else{
					$ljID['itemid'] = 'null';
					$ljURL	= 'null';	
				}
			}
			
		}else{
			$ljID['itemid'] = 'null';
			$ljURL	= 'null';	
		}
		## end case LJ Syndicate ##
		
		//database insert OR update
		if($_POST['edit']){
			$db->query("UPDATE int_entry SET
							subject 	= '".$_POST['subject']."',
							content 	= '".$_POST['content']."',
							content_p 	= '".$parsedContent."',
							catid		= '".$catID."',
							intime		= '".$date."',
							comments	= '".$_POST['comments']."',
							image		= '".$imageTag."'
							WHERE entryid = '".$newEntryID."'");
			
			$db->query("DELETE FROM int_keywords WHERE entryid = '".$newEntryID."'");
			
			//get rid of cache
			$smarty->clear_cache("index.htm","entry|$newEntryID");
		}else{
			$res = $db->query("INSERT INTO int_entry SET
							entryid 	= '".$newEntryID."',
							subject 	= '".$_POST['subject']."',
							content 	= '".$_POST['content']."',
							content_p 	= '".$parsedContent."',
							catid		= '".$catID."',
							intime		= '".$date."',
							image		= '".$imageTag."',
							ljid		= ".$ljID['itemid'].",
							ljurl		= ".$ljURL.",
							comments	= '".$_POST['comments']."'");
		}
		
		//get rid of cache
		$smarty->clear_cache(null,"______rootpage");
		$smarty->clear_cache(null,"keyword");
		
		
		//keywords check
		$keywords = explode(",",$_POST['keywords']);
		$keywords = array_diff($keywords,array(''));
		foreach($keywords as $keyword){
			
			//get rid of trailing spaces
			$keyword = trim($keyword);	
			
			//last bogus check
			if(!empty($keyword)){
				//check if already in database
				if($keyWordID = $db->getOne("SELECT wordid FROM int_keyword WHERE word = '".$keyword."'")){
					//kewl push a reference to it into the database
					$db->query("INSERT INTO int_keywords(entryid,wordid) VALUES('".$newEntryID."','".$keyWordID."')");
				}else{
					//no so kewl, insert the keyword into the database, then push a reference
					$keyWordID = (int)$db->getOne("SELECT max(wordid) + 1 FROM int_keyword");
					$db->query("INSERT INTO int_keyword VALUES('".$keyWordID."','".$keyword."')");
					$db->query("INSERT INTO int_keywords(entryid,wordid) VALUES('".$newEntryID."','".$keyWordID."')");
				}
			}
		}
		
		
		
		//kill empty sections and unused keywords
		# keywords
		$keywords = array();
		$keywords = $db->getCol("SELECT DISTINCT wordid FROM int_keywords");
		if(!empty($keywords)){
			$db->query("DELETE FROM int_keyword WHERE wordid NOT IN(".implode(",",$keywords).")");
			$db->query("OPTIMIZE TABLE int_keyword");
		}
		
		#sections
		$sections = array();
		$sections = $db->getCol("SELECT DISTINCT catid FROM int_entry");
		if(!empty($sections)){
			$db->query("DELETE FROM int_category WHERE catid NOT IN(".implode(",",$sections).")");
			$db->query("OPTIMIZE TABLE int_category");
		}
		
		
		//RSS compiler
		recompileRSS();
		if($catID > 0){
			recompileRSS($catID);
		}
		
		//redirect
		header("Location: " . SERVER_ROOT . "entry/" . $newEntryID . "/");
		exit;
	}
	
	//fetch all existing keywords
	$keywords = array();
	$keywords = $db->getAssoc("SELECT word, word FROM int_keyword ORDER BY word");
	
	//are we editing an existing post?
	if($_GET['table'] == "update"){
		$edit = $db->getRow("SELECT * FROM int_entry WHERE entryid = '".(int)$_GET['id']."'");
		$entryKeys = $db->getAssoc("SELECT int_keyword.word,int_keyword.word FROM int_keywords 
														LEFT JOIN int_keyword ON int_keywords.wordid = int_keyword.wordid
														WHERE int_keywords.entryid = '".(int)$_GET['id']."'");
		
		//get rid of recurring keywords in dropdown
		$keywords = array_diff($keywords,$entryKeys);
		
		$edit['keywords'] = implode(", ",$entryKeys);
		
		//pass data to smarty
		$smarty->assign("edit",$edit);
	}
	
	//give some default settings to smarty
	$smarty->assign(array(
							"sections"	=>	$db->getAssoc("SELECT catid, fullName FROM int_category ORDER BY fullName"),
							"keywords"	=>	$keywords
							));
	
	//set breadcrumbs
	if($_POST['edit'] or $_GET['table'] == "update"){
		$breadCrumbs[] = "...";
		$_SESSION['tempEntryID'] = (int)$_GET['id'];
	}else{
		$breadCrumbs[] = "...";
		$_SESSION['tempEntryID'] = (int)$db->getOne("SELECT max(entryid) FROM int_entry") + 1;
	}
	
	//select smarty template
	$smarty->assign("template","add.htm");
?>