<?
	/****************************************************************************
	* Software distributed under the License is distributed on an "AS IS" 		*
	* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 	*
	* License for a specific language governing rights and limitations under	*
	* the License. 																*
	* 																			*
	*	The Original Code is - InTerra Blog Machine   				            *
	* 																			*
	*	The Initial Developer of the Original Code is 							*
	* 																			*
	* 			Kulikov Alexey <alex [at] essentialmind [dot] com>	 			*
	* 																			*
	* 							All Rights Reserved. 							*
	* 																			*
	* Read the full license in the license.rtf file distributed along with		*
	* this software package.													*
	*****************************************************************************/
	
	/***
	 This is the main configuration file, which shall be used to tune your blog,
	 please follow comments for settings
	***/
	
	/***
	 database connection details
	***/
	define('DB_HOST','localhost'); 	//database host
	define('DB_NAME','interra');	//database name
	define('DB_USER','user');		//database user
	define('DB_PASS','password');	//database password
	
	
	/***
	 TEMPLATE_ROOT -- 	path to the template set of your blog, this
	 					path must be relative to PATH_ROOT, typically
	 					this setting must not be changed
	 ***/
	define('TEMPLATE_ROOT','templates/main/');

	/***
	 SERVER_ROOT --		absolute WWW path to the root of your application
	 					ending with a slah, eg. http://www.blog.com/
	***/
	define('SERVER_ROOT','http://dull.ru/');
	
	/***
	 SMARTY Specific Settings
	***/
	define('SMARTY_ALLOW_CACHE',false);		// cache pages?
	define('SMARTY_CACHE_TIME',3600);		// cache by default for 10 minutes
	define('SMARTY_FORCE_FLUSH',86400);		// folce full cache flush once every xxxxx seconds
	define('SMARTY_COMPILE_CHECK',true);	// check templates if they need recompilation
	define('SMARTY_DEBUG',false);			// show smarty debug console
	define('SMARTY_SUBDIRS',true);			// is smarty allowed to create sbudirs?
	
	/***
	 MAILBOT is the return path for the e-mail bot who sends out mail notifications
	***/
	define('MAILBOT','Mail Robot <noreply@inses.ru>');
	
	/***
	 BLOGMASTER is the e-mail address of the blog admin
	***/
	define('BLOGMASTER','you@yourblog.com');
	
	/***
	 BLOGMASTER_P is the blog administration password
	 BLOGMASTER_U is the blog administration login name
	***/
	define('BLOGMASTER_P','user');
	define('BLOGMASTER_U','password');
	
	/***
	 RSS_HEADER header of the RSS feed
	 RSS_DESC description of the RSS feed
	***/
	define('RSS_HEADER','InTerra Blog Machine');
	define('RSS_DESC','InTerra Blog Machine RSS feed, sent from the main page');
	
	/***
	 ENABLE_PAGERS - true if pagers are enables, otherwise false, this operation costs 1 database query
	***/
	define('ENABLE_PAGERS',true);
	
	/***
	 PER_PAGE is the number of posts shown per page in section and last enttry views
	***/
	define('PER_PAGE',15);
	
	/***
	 INDIRECT_PATH is the path to your link tracker, if any, leave commented out if not used
	***/
	//define('INDIRECT_PATH','http://www.inses.ru/link/?');
	
	/***
	 ALLOW_FILES -- allow file uploads
	***/
	define('ALLOW_FILES',true);
	
	/***
	 ALLOW_KEYWORDS -- whether keywords are allowed 
	***/
	define('ALLOW_KEYWORDS',true);
	
	/***
	 ALLOW_TEASER_IMAGE -- allow teaser image for posts, this will links a thumbnail to every post, makes things look sexy
	 sometimes. Two additional settings (if true) are TI_WIDTH and TI_HEIGTH -- these are the resize parameters for the
	 teaser image
	***/
	define('ALLOW_TEASER_IMAGE',true);
	define('TI_WIDTH',125);
	define('TI_HEIGHT',100);
	define('USE_MAGICK',false);			//in case ImageMagick is installed on the server, one can use it insted of GD
	define('MAGICK_PATH',null);			//absolute path to ImageMagick on server
	
	/***
	 ENABLE_LJ -- is this an LJ syndicated account?
	***/
	define('ENABLE_LJ',false);
	define('LJ_USER','ljuser');
	define('LJ_PASS','ljpass');
	
	/***
	 CHARSET -- default charset used to encode all text and e-mail, probably no need to change this =)
	***/
	define('CHARSET','windows-1251');

	/***
	 NOW -- current server time, can be shifted with an offset
	***/
	define('NOW', time());
?>